inline void setPixel(int x, int y, int color) {
  unsigned char* p = (unsigned char*)(SCREEN_BASE_ADDRESS + ((x >> 1) + (y << 7) + (y << 5)));
  *p = (x & 1) ? ((*p & 0xF0) | color) : ((*p & 0x0F) | (color << 4));
}

inline int getPixel(int x, int y) {
  unsigned char* p = (unsigned char*)(SCREEN_BASE_ADDRESS + ((x >> 1) + (y << 7) + (y << 5)));
  return ((x & 1) ? (*p & 0x0F) : (*p >> 4));
}

inline void clip_setpix(int x, int y, char color)
{
 unsigned char *byte=SCREEN_BASE_ADDRESS+x/2+SCREEN_WIDTH*y/2;
 if(x>=SCREEN_WIDTH || x<0 || y>=SCREEN_HEIGHT || y<0) return ;
 if(!(x%2))
 {
   *byte=(0b00001111&(*byte))|(color<<4);
 }
 else
 {
   *byte=(0b11110000&(*byte))|color;
 }
}
inline void setpix(int x, int y, char color)
{
 unsigned char *byte=SCREEN_BASE_ADDRESS+x/2+SCREEN_WIDTH*y/2;
 if(!(x%2))	//si paire alors
 {
   *byte=(0b00001111&(*byte))|(color<<4);
 }
 else
 {
   *byte=(0b11110000&(*byte))|color;
 }
}

void DrawSprite(int xx, int yy, int height, int width, unsigned char *sprite, char gmode)		//gmode=0 : white is translucent    gmode=2 : REPLACE
{	
	int x=0,y=0,temp=0;
	for(x=0;x<width;x++)
	{
		for(y=0;y<height;y++)
		{
			temp=*(sprite+x+y*width);	//couleur du sprite
			switch(gmode)
			{
				case 0: //WHITE is translucent
				if(temp!=WHITE) clip_setpix(xx+x,yy+y,temp);
				break;
				case 1: //INVERT
				//clip_setpix(xx+x,yy+y,15-getPixel(xx+x,yy+y)-temp);
				break;
				case 2: //REPLACE  
				clip_setpix(xx+x,yy+y,temp);
				break;
			}
			
		}
	}
}
void EraseSprite(int xx, int yy, int height, int width, unsigned char *sprite, char color)
{
	int x=0,y=0,temp=0;
	for(x=0;x<width;x++)
	{
		for(y=0;y<height;y++)
		{
			temp=*(sprite+x+y*width);
			if(temp!=WHITE) clip_setpix(xx+x,yy+y,color);
		}
	}
}

char* GetSprite(int x0, int y0, int height, int width, char *buffer)
{
	int x=0,y=0;
	for(x=0;x<width;x++)
	{
		for(y=0;y<height;y++)
		{
			*(buffer+x+y*width)=getPixel(x0+x, y0+y);
		}
	}
	return buffer;
}



inline void clearScreen() {
  memset(SCREEN_BASE_ADDRESS, 0xFF, SCREEN_BYTES_SIZE);
}

void FillScreen(void)
{
  memset(SCREEN_BASE_ADDRESS, 0b11110011, SCREEN_BYTES_SIZE);
}

void DrawLineHoriz(int y, char color)
{
 memset(SCREEN_BASE_ADDRESS+y*SCREEN_WIDTH/2,color<<4|color,SCREEN_WIDTH/2);
}

/*void DrawLineHoriz2(int x0, int x1, int y, char color)
{
 int x;
 if(x1>=x0) for(x=x0; x<=x1; x++) clip_setpix(x,y,color);
 else for(x=x0; x>=x1; x--) clip_setpix(x,y,color);
}*/

void DrawLineHoriz2(int x0, int x1, int y, char color)	//Cette fonction est rapide mais non clipe
{
 int x;
 if(x1>=x0)
 {
  if(x0%2)
  {
   clip_setpix(x0,y,color);
   x0++;
  }
  if(x1%2)
  {
   clip_setpix(x1,y,color);
   x1--;
  }
  memset(SCREEN_BASE_ADDRESS+x0/2+y*SCREEN_WIDTH/2,color<<4|color,(x1-x0)/2+1);
 }
 else
 {
  if(x0%2)
  {
   clip_setpix(x0,y,color);
   x0--;
  }
  if(x1%2)
  {
   clip_setpix(x1,y,color);
   x1++;
  }
  memset(SCREEN_BASE_ADDRESS+x1/2+y*SCREEN_WIDTH/2,color<<4|color,(x0-x1)/2+1);
 }
}

void DrawLineVert(int x, char color)
{
 int y;
 //for(y=0;y<SCREEN_HEIGHT;y++) setPixel(x,y,color);
 unsigned char *byte=SCREEN_BASE_ADDRESS+x/2;
 for(y=0;y<SCREEN_HEIGHT;y++)
 {
  if(!(x%2))
  {
    *byte=(0b00001111&(*byte))|(color<<4);
  }
  else
  {
    *byte=(0b11110000&(*byte))|color;
  }
  byte+=SCREEN_WIDTH/2;
 }
}
void DrawLineVert2(int x, int y0, int y1, char color)
{
 int y;
 if(y0<=y1) 
 {
  for(y=y0;y<=y1;y++) clip_setpix(x,y,color); return ;
 }
 else
 {
  for(y=y0;y>=y1;y--) clip_setpix(x,y,color); return ;
 }
}
void FillRect(int x0, int y0 , int x1, int y1, char color)
{
 int y;
 if(y1>=y0)
 {
  for(y=y0;y<=y1;y++) DrawLineHoriz2(x0, x1, y, color);
 }
 else
 {
  for(y=y0;y>=y1;y--) DrawLineHoriz2(x0, x1, y, color);
 }
}

void DrawLine(int x0, int y0, int x1, int y1, char color)
{
 long x,y,a=div(1024*(y1-y0),x1-x0);
 //printf("1000*a=%d",a);
 if(y1==y0)
 {
  DrawLineHoriz2(x0, x1, y0, color);
  return ;
 }
 if(x1==x0)
 {
  DrawLineVert2(x0, y0, y1, color);
  return ;
 }
 if(abs(a)<1024 && x1>x0)
 {
  for(x=x0;x<=x1;x++)
  {
   clip_setpix(x,y0+(a*(x-x0))/1024,color);
   return ;
  }
 }
 if(abs(a)<1024 && x1<x0)
 {
  for(x=x0;x>=x1;x--)
  {
   clip_setpix(x,y0+(a*(x-x0))/1024,color);
   return ;
  }
 }
 if(abs(a)>=1024 && y1>y0)
 {
  for(y=y0;y<=y1;y++)
  {
   clip_setpix(div(1024*(y-y0),a)+x0,y,color);
   return ;
  }
 }
 if(abs(a)>=1024 && y1<y0)
 {
  for(y=y0;y>=y1;y--)
  {
   clip_setpix(div(1024*(y-y0),a)+x0,y,color);
   return ;
  }
 }
}

void ScrollScreenLeft(void)	//fonctionne
{
 //printf("taille long=%d",sizeof(long));
 unsigned char *ptr=SCREEN_BASE_ADDRESS;
 int i,y;
 for(y=0;y<SCREEN_HEIGHT;y++)
 {
 	for(i=y*SCREEN_WIDTH/2;i<(y+1)*SCREEN_WIDTH/2-1;i++)
 	{
 		ptr[i]=(ptr[i]<<4) | (ptr[i+1]>>4);
 	}
 	ptr[i]=(ptr[i]<<4) | WHITE;
 }
}

void ScrollScreenRight(void)	//fonctionne
{
 //printf("taille long=%d",sizeof(long));
 unsigned char *ptr=SCREEN_BASE_ADDRESS;
 int i,y;
 for(y=0;y<SCREEN_HEIGHT;y++)
 {
 	for(i=(y+1)*SCREEN_WIDTH/2-1;i>(y)*SCREEN_WIDTH/2;i--)
 	{
 		ptr[i]=(ptr[i]>>4) | ((ptr[i-1]<<4)&0xF0);
 	}
 	ptr[i]=(ptr[i]>>4) | (WHITE<<4);
 }
}

void ScrollScreenLeft2(void) //scroll by two pixels at once
{
 //printf("taille long=%d",sizeof(long));
 unsigned long *ptr=SCREEN_BASE_ADDRESS;
 long x,y;
 for(y=0;y<SCREEN_HEIGHT;y++)
 {
  memcpy(SCREEN_BASE_ADDRESS+y*SCREEN_WIDTH/2,SCREEN_BASE_ADDRESS+y*SCREEN_WIDTH/2+1,SCREEN_WIDTH/2-1);
 }
}
void ScrollScreenLeft3(void)	//fonctionne
{
 //printf("taille long=%d",sizeof(long));
 unsigned long *ptr=SCREEN_BASE_ADDRESS;
 unsigned long data;
 int i,y;
 for(y=0;y<SCREEN_HEIGHT;y++)
 {
 	for(i=y*SCREEN_WIDTH/8;i<(y+1)*SCREEN_WIDTH/8-1;i++)
 	{
 		data=ptr[i]&0b100000001000000010000000;
 		ptr[i]=(ptr[i]<<4) | (ptr[i]^(data<<1)) | data<<1 | (ptr[i+1]>>28);
 	}
 	ptr[i]=(ptr[i]<<4) | WHITE;
 }
}

void ScrollScreenDown(void)
{
	int i;
	long *ptr=(long *)SCREEN_BASE_ADDRESS;
	for(i=0;i<SCREEN_WIDTH/8*(SCREEN_HEIGHT-1);i++)
	{			
		ptr[i]=ptr[i+SCREEN_WIDTH/8];
	}
	for(i=SCREEN_WIDTH/8*(SCREEN_HEIGHT-1);i<SCREEN_WIDTH/8*SCREEN_HEIGHT;i++) ptr[i]=0xFFFFFFFF;	//erase the last line
}
void ScrollScreenUp(void)
{
	int i;
	long *ptr=(long *)SCREEN_BASE_ADDRESS;
	for(i=SCREEN_WIDTH/8*SCREEN_HEIGHT-1;i>=SCREEN_WIDTH/8;i--)
	{			
		ptr[i]=ptr[i-SCREEN_WIDTH/8];
	}
	for(i=0;i<SCREEN_WIDTH/8;i++) ptr[i]=0xFFFFFFFF;	//erase the last line
}